"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importDefault(require("lodash"));
const safe_1 = __importDefault(require("colors/safe"));
const status_1 = __importDefault(require("../status"));
safe_1.default.enable();
function getColorFns(enabled) {
    if (enabled) {
        return {
            forStatus(status) {
                return {
                    [status_1.default.AMBIGUOUS]: safe_1.default.red.bind(safe_1.default),
                    [status_1.default.FAILED]: safe_1.default.red.bind(safe_1.default),
                    [status_1.default.PASSED]: safe_1.default.green.bind(safe_1.default),
                    [status_1.default.PENDING]: safe_1.default.yellow.bind(safe_1.default),
                    [status_1.default.SKIPPED]: safe_1.default.cyan.bind(safe_1.default),
                    [status_1.default.UNDEFINED]: safe_1.default.yellow.bind(safe_1.default),
                    [status_1.default.UNKNOWN]: safe_1.default.yellow.bind(safe_1.default),
                }[status];
            },
            location: safe_1.default.gray.bind(safe_1.default),
            tag: safe_1.default.cyan.bind(safe_1.default),
        };
    }
    else {
        return {
            forStatus(status) {
                return lodash_1.default.identity;
            },
            location: lodash_1.default.identity,
            tag: lodash_1.default.identity,
        };
    }
}
exports.default = getColorFns;
//# sourceMappingURL=get_color_fns.js.map