import { Dictionary } from 'lodash';
import { messages } from '@cucumber/messages';
export interface IGetPickleLocationRequest {
    gherkinDocument: messages.IGherkinDocument;
    pickle: messages.IPickle;
}
export interface IGetStepKeywordRequest {
    pickleStep: messages.Pickle.IPickleStep;
    gherkinStepMap: Dictionary<messages.GherkinDocument.Feature.IStep>;
}
export interface IGetScenarioDescriptionRequest {
    pickle: messages.IPickle;
    gherkinScenarioMap: Dictionary<messages.GherkinDocument.Feature.IScenario>;
}
export declare function getScenarioDescription({ pickle, gherkinScenarioMap, }: IGetScenarioDescriptionRequest): string;
export declare function getStepKeyword({ pickleStep, gherkinStepMap, }: IGetStepKeywordRequest): string;
export declare function getPickleStepMap(pickle: messages.IPickle): Dictionary<messages.Pickle.IPickleStep>;
export declare function getPickleLocation({ gherkinDocument, pickle, }: IGetPickleLocationRequest): messages.ILocation;
