"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const UncaughtExceptionManager = {
    registerHandler(handler) {
        if (typeof window === 'undefined') {
            process.addListener('uncaughtException', handler);
        }
        else {
            window.onerror = handler;
        }
    },
    unregisterHandler(handler) {
        if (typeof window === 'undefined') {
            process.removeListener('uncaughtException', handler);
        }
        else {
            window.onerror = undefined;
        }
    },
};
exports.default = UncaughtExceptionManager;
//# sourceMappingURL=uncaught_exception_manager.js.map