"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var IdGenerator = /** @class */ (function () {
    function IdGenerator() {
        this.generatedIds = [];
    }
    IdGenerator.prototype.generate = function (title) {
        var id = title.toLowerCase().replace(/[^a-z0-9]+/g, '-');
        if (id.match(/^-*$/)) {
            id = 'id';
        }
        if (!this.idAlreadyUsed(id)) {
            this.generatedIds.push(id);
            return id;
        }
        var index = 1;
        while (this.idAlreadyUsed(id + "-" + index)) {
            index += 1;
        }
        this.generatedIds.push(id + "-" + index);
        return id + "-" + index;
    };
    IdGenerator.prototype.idAlreadyUsed = function (id) {
        return this.generatedIds.includes(id);
    };
    return IdGenerator;
}());
exports.default = IdGenerator;
//# sourceMappingURL=IdGenerator.js.map