"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var CucumberQueryContext_1 = __importDefault(require("../../CucumberQueryContext"));
var isNumber_1 = __importDefault(require("./isNumber"));
var GherkinQueryContext_1 = __importDefault(require("../../GherkinQueryContext"));
var ErrorMessage_1 = __importDefault(require("./ErrorMessage"));
var statusName_1 = __importDefault(require("./statusName"));
var StatusIcon_1 = __importDefault(require("./StatusIcon"));
var UriContext_1 = __importDefault(require("../../UriContext"));
var ExamplesTableBody = function (_a) {
    var rows = _a.rows;
    return (react_1.default.createElement("tbody", null, rows.map(function (row, i) { return (react_1.default.createElement(RowOrRows, { row: row, key: i })); })));
};
var RowOrRows = function (_a) {
    var row = _a.row;
    var gherkinQuery = react_1.default.useContext(GherkinQueryContext_1.default);
    var cucumberQuery = react_1.default.useContext(CucumberQueryContext_1.default);
    var uri = react_1.default.useContext(UriContext_1.default);
    var testStepResult = cucumberQuery.getWorstTestStepResult(cucumberQuery.getPickleTestStepResults(gherkinQuery.getPickleIds(uri, row.id)));
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("tr", { className: "cucumber-status--" + statusName_1.default(testStepResult.status) },
            react_1.default.createElement("td", { className: "cucumber-table__cell" },
                react_1.default.createElement(StatusIcon_1.default, { status: testStepResult.status })),
            row.cells.map(function (cell, j) { return (react_1.default.createElement("td", { className: "cucumber-table__cell", key: j, style: { textAlign: isNumber_1.default(cell.value) ? 'right' : 'left' } }, cell.value)); })),
        react_1.default.createElement(ErrorMessageRow, { key: "row-error", testStepResult: testStepResult, colSpan: row.cells.length })));
};
var ErrorMessageRow = function (_a) {
    var testStepResult = _a.testStepResult, colSpan = _a.colSpan;
    if (!testStepResult.message)
        return null;
    return (react_1.default.createElement("tr", { className: "cucumber-status--" + statusName_1.default(testStepResult.status) + " cucumber-table__cell" },
        react_1.default.createElement("td", null, "\u00A0"),
        react_1.default.createElement("td", { colSpan: colSpan },
            react_1.default.createElement(ErrorMessage_1.default, { message: testStepResult.message }))));
};
exports.default = ExamplesTableBody;
//# sourceMappingURL=ExamplesTableBody.js.map