"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var messages_1 = require("@cucumber/messages");
var react_1 = __importDefault(require("react"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var statusName_1 = __importDefault(require("./statusName"));
var StatusIcon = function (_a) {
    var status = _a.status;
    return (react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: statusIcon(status), size: "1x", className: "cucumber-status--" + statusName_1.default(status) }));
};
exports.default = StatusIcon;
var statusIcon = function (status) {
    var _a;
    return (_a = {},
        // Keep the same order as in messages.proto - for readability's sake
        _a[messages_1.messages.TestStepFinished.TestStepResult.Status.PASSED] = free_solid_svg_icons_1.faCheckCircle,
        _a[messages_1.messages.TestStepFinished.TestStepResult.Status.SKIPPED] = free_solid_svg_icons_1.faStopCircle,
        _a[messages_1.messages.TestStepFinished.TestStepResult.Status.PENDING] = free_solid_svg_icons_1.faPauseCircle,
        _a[messages_1.messages.TestStepFinished.TestStepResult.Status
            .UNDEFINED] = free_solid_svg_icons_1.faQuestionCircle,
        _a[messages_1.messages.TestStepFinished.TestStepResult.Status.AMBIGUOUS] = free_solid_svg_icons_1.faInfoCircle,
        _a[messages_1.messages.TestStepFinished.TestStepResult.Status.FAILED] = free_solid_svg_icons_1.faTimesCircle,
        _a[messages_1.messages.TestStepFinished.TestStepResult.Status.UNKNOWN] = free_solid_svg_icons_1.faQuestionCircle,
        _a)[status];
};
//# sourceMappingURL=StatusIcon.js.map